-- A set of different-looking buff bars. Inspired by Elkano's Buff Bars.
-- The player can left-click on a buff to cancel it.

-- Set our default placement values. If a SavedVariable file exists, then these will be overwritten after all our code is loaded. If it doesn't, then these will work as defaults.
placement = {x = 0, y = 0}
barHeight = 80
barWidth = 80
barAlpha = 1
role = 1
curTarget = nil
local losingCharge = false
local curCharge = 0
local debugmode = false
barindex = 0
rightdown = false
prioritylist = {"Opportunity","Searing Vitality","Dark Touch"}

--table that stores each bars font,alpha,color information for each role
barStats = {
	{
		{},
		{},
		{},
		{},
		{},
		{},
	},
	{
		{},
		{},
		{},
		{},
		{},
		{},
	},
	{
		{},
		{},
		{},
		{},
		{},
		{},
	},
	{
		{},
		{},
		{},
		{},
		{},
		{},
	},
	{
		{},
		{},
		{},
		{},
		{},
		{},
	},
}
local mashmacro = "cast Fireball"

-- global varable for moving buffs with the mouse and the table id
moveBuffs = false
moveBuffsTable = {function () resynch = true end, "PowerBuffs", "refresh"}

-- Create our context so we can do rendering.
local context = UI.CreateContext("HUD")
local bars = {}

local bar = UI.CreateFrame("Frame", "Bar", context)
local bar1 = UI.CreateFrame("Frame", "Bar", context)
local bar2 = UI.CreateFrame("Frame", "Bar", context)
local bar3 = UI.CreateFrame("Frame", "Bar", context)
local bar4 = UI.CreateFrame("Frame", "Bar", context)
local bar5 = UI.CreateFrame("Frame", "Bar", context)
table.insert(bars,bar)
table.insert(bars,bar1)
table.insert(bars,bar2)
table.insert(bars,bar3)
table.insert(bars,bar4)
table.insert(bars,bar5)
for i = 1,table.maxn(bars) do
    --bars[i]:SetPoint(0,0, UIParent, 0,0,100,(i)*100)
    bars[i]:SetMouseMasking("limited")
    bars[i].solid = UI.CreateFrame("Frame", "Solid", bar)
    bars[i].solid:SetPoint(0,0,bars[i],0,0,0,(i-1)*100)
    bars[i]:SetWidth(barWidth)
    bars[i]:SetHeight(barHeight)
    bars[i].solid:SetBackgroundColor(1,1,1)
    bars[i].solid:SetVisible(false)
end

-- This is our update function, called once every frame.
function bar:Tick(time)
		--bar.Event.RightClick = mashmacro
end






local function refresh(time)
    -- Get the list of buffs from the player. Note that "player" can be replaced by "player.target" to turn this into a target's-buff-bar display.
    local bufflist = Inspect.Buff.List("player")
    local tarBuffList = {}
    local abilityList = Inspect.Ability.List()
    local tarBuffDetails = {}
    -- buff id may be needed if canceling buffs is disired
    local bbars = {}
    local tarbbars = {}
    local abars = {}

    for i = 1,table.maxn(bars) do
        bars[i].solid:SetVisible(false)
    end
    if not bufflist then return end -- If we don't get anything, then we don't currently have information about the player. This may happen when the player is logging in or teleporting long distances.

    local buffdetails = Inspect.Buff.Detail("player", bufflist) -- Retrieve the details for all of our buffs. If there were only certain buffs we cared about, we could filter them out before asking for detail.


    for id, bufff in pairs(buffdetails) do
        bufff.id = id  -- Make a copy of the ID, because we'll need it
        if (bufff.name == "Pyromancer's Armor") and (bufff.remaining > 20) then
        else
            bbars[bufff.name]=bufff
        end
    end


    if curTarget and (not (curTarget == Inspect.Unit.Lookup("player"))) then
        tarBuffList = Inspect.Buff.List(curTarget)
        if curTarget and tarBuffList then
            tarBuffDetails = Inspect.Buff.Detail(curTarget,tarBuffList)
            for id,v in pairs(tarBuffDetails) do
                 if v then
                 	if not (Inspect.Unit.Lookup("player") == v.caster) then  --if its not my debuff
                 	    tarBuffDetails[id] = nil
                 	end
                 end
            end
            for id, bufff in pairs(tarBuffDetails) do
                bufff.id = id  -- Make a copy of the ID, because we'll need it
                tarbbars[bufff.name]= bufff
            end
            if tarbbars["Void Life"] and bbars["Entropic Veil"] then
                bars[6].solid:SetVisible(true)
            end
            if not tarbbars["Searing Vitality"] then
                bars[2].solid:SetVisible(true)
                --mashmacro = "cast [notactive] Internalize Charge\ncast Leeching Flames\ncast Searing Vitality"

            end
            if not tarbbars["Dark Touch"] then
               bars[3].solid:SetVisible(true)
               -- mashmacro = "cast [notactive] Internalize Charge\ncast Leeching Flames\ncast Dark Touch"
            end
        end
    end



    --process target buffs if and only if we have a valid target :)






    if losingCharge then
        if (bbars["Internalize Charge"]) then
            bars[5].solid:SetVisible(true)
        else
            losingCharge = false
            bars[5].solid:SetVisible(false)
        end

    end

    for k = 1,table.maxn(prioritylist) do
        local p = prioritylist[k]
        if bbars["Pyromancer's Armor"] then
            if bbars["Pyromancer's Armor"].remaining < 20 then
                bars[1].solid:SetVisible(true)
            end
        end
        if (bbars[p]) and (k == 1) then
            bars[1].solid:SetVisible(true)
	    	--mashmacro = "cast [notactive] Internalize Charge\ncast Cinder Burst"

        end
        if not bbars["Pillaging Stone"] then
            bars[4].solid:SetVisible(true)
        end
        if bbars["Pillaging Stone"] then
            if bbars["Pillaging Stone"].remaining < 20 then
                bars[4].solid:SetVisible(true)
            end
            if bbars["Pillaging Stone"].stack then
                if bbars["Pillaging Stone"].stack < 4 then
                    bars[4].solid:SetVisible(true)
                end
            else
                bars[4].solid:SetVisible(true)
            end
        end

--         if barStats[role][k]["aId"] and barStats[role][k]["cooldown"] then
--             local buff =  Inspect.Ability.Detail(barStats[role][k]["aId"])
--             if buff then
--                 buff.id = barStats[role][k]["aId"]
--                 abars[buff.name]=buff
--             end
--         end
    end
end

local resynch = false
local function tick()

  if resynch or movebuffs then
    -- A recalculation has been queued, so go ahead and recalculate.
    refresh(Inspect.Time.Frame())
    resynch = false
  else
    -- Just do a tick refresh
    local time = Inspect.Time.Frame()


	    bar:Tick(time)


    end
end

local function checkBuffs(unit,buffs)
    local time = Inspect.Time.Frame()
    bDetails = {}
    for i in pairs(buffs) do
        v = Inspect.Buff.Detail(unit,i)
        v.id = i
        bDetails[v.name] = v
    end

    if unit == Inspect.Unit.Lookup("player") then
        for j,k in ipairs(prioritylist) do
                if bDetails[k] then
                    resynch = true
                    return
                end

        end

    else

        if (unit == curTarget) then
            resynch = true
            return
        end


    end
 end

function chargeChange(units)
    for k,v in pairs(units) do
        if v < (curCharge-2) then
            losingCharge = true
            curCharge = v
        elseif v < curCharge then

        else
            losingCharge = false
            curCharge = v
        end
    end
    return
end

table.insert(Event.Unit.Detail.Charge, {chargeChange, "mash", "charge change"})
table.insert(Event.Buff.Add, {checkBuffs, "mash", "refresh"})
table.insert(Event.Buff.Change, {checkBuffs, "mash", "refresh"})
table.insert(Event.Buff.Remove, {
 function (unit,buffs)
    if  (unit == Inspect.Unit.Lookup("player")) or (unit == curTarget) then
        resynch = true
    else
        resynch = false
    end
 end
, "mash", "refresh"})

table.insert(Event.Ability.Cooldown.Begin,{function (cooldowns)
--     local abars = {}
--     for i,c in pairs(cooldowns) do
--         local v = Inspect.Ability.Detail(i)
--         if v then
--             v.id = i
--             abars[v.name] = v
--         end
--     end
--
--     for k = 1,table.maxn(powerBuffs[role]) do
--         p = powerBuffs[role][k]
--
--         if barStats[role][k] then
--             if abars[p] then
--                 if barStats[role][k]["cooldown"] then
--                     barStats[role][k]["aId"] = abars[p].id
--                 end
--
--             end
--         end
--
--     end
--     resynch = true
 end, "mash", "refresh"})

table.insert(Event.Ability.Target, {function (abilities)
		local abilities = Inspect.Ability.List()
		meows = Inspect.Ability.Detail(abilities)
		for k,v in pairs(meows) do
		    if v.target then
			    if ((v.name == "Transmogrify") or (v.name == "Vile Spores") or (v.name == "Fireball")) and (not (v.target == Inspect.Unit.Lookup("player"))) then
    		        curTarget = v.target
			    end

			end
		end

-- 		for k,v in pairs(abilities) do
-- 			if v. then
--
-- 			end
-- 			if not (v == Inspect.Unit.Lookup("player")) then
-- 			    curTarget = v
-- 			    break
-- 			end
-- 		end
		resynch = true
end, "mash", "target change"})

-- Our update event. This triggers every single frame.
table.insert(Event.System.Update.Begin, {tick, "mash", "refresh"})
